searchNodes=[{"doc":"Integrates Phoenix with Ecto.It implements many protocols that makes it easier to use Ecto with Phoenix either when working with HTML or JSON.","ref":"Phoenix.Ecto.html","title":"Phoenix.Ecto","type":"module"},{"doc":"Callback implementation for Application.start/2.","ref":"Phoenix.Ecto.html#start/2","title":"Phoenix.Ecto.start/2","type":"function"},{"doc":"A plug that does some checks on your application repos.Checks if the storage is up (database is created) or if there are any pending migrations. Both checks can raise an error if the conditions are not met.Plug options:otp_app - name of the application which the repos are fetched from","ref":"Phoenix.Ecto.CheckRepoStatus.html","title":"Phoenix.Ecto.CheckRepoStatus","type":"module"},{"doc":"Callback implementation for Plug.call/2.","ref":"Phoenix.Ecto.CheckRepoStatus.html#call/2","title":"Phoenix.Ecto.CheckRepoStatus.call/2","type":"function"},{"doc":"Callback implementation for Plug.init/1.","ref":"Phoenix.Ecto.CheckRepoStatus.html#init/1","title":"Phoenix.Ecto.CheckRepoStatus.init/1","type":"function"},{"doc":"A plug to allow concurrent, transactional acceptance tests with [Ecto.Adapters.SQL.Sandbox] (https://hexdocs.pm/ecto_sql/Ecto.Adapters.SQL.Sandbox.html).ExampleThis plug should only be used during tests. First, set a flag to enable it in config/test.exs:config :your_app, sql_sandbox: trueAnd use the flag to conditionally add the plug to lib/your_app/endpoint.ex:if Application.get_env(:your_app, :sql_sandbox) do plug Phoenix.Ecto.SQL.Sandbox endIt's important that this is at the top of endpoint.ex, before any other plugs.Then, within an acceptance test, checkout a sandboxed connection as before. Use metadata_for/2 helper to get the session metadata to that will allow access to the test's connection. Here's an example using Hound:use Hound.Helpers setup do :ok = Ecto.Adapters.SQL.Sandbox.checkout(YourApp.Repo) metadata = Phoenix.Ecto.SQL.Sandbox.metadata_for(YourApp.Repo, self()) Hound.start_session(metadata: metadata) :ok endConcurrent end-to-end tests with external clientsConcurrent and transactional tests for external HTTP clients is supported, allowing for complete end-to-end tests. This is useful for cases such as JavaScript test suites for single page applications that exercise the Phoenix endpoint for end-to-end test setup and teardown. To enable this, you can expose a sandbox route on the Phoenix.Ecto.SQL.Sandbox plug by providing the :at, and :repo options. For example:plug Phoenix.Ecto.SQL.Sandbox, at: &quot;/sandbox&quot;, repo: MyApp.Repo, timeout: 15_000 # the defaultThis would expose a route at &quot;/sandbox&quot; for the given repo where external clients send POST requests to spawn a new sandbox session, and DELETE requests to stop an active sandbox session. By default, the external client is expected to pass up the &quot;user-agent&quot; header containing serialized sandbox metadata returned from the POST request, but this value may customized with the :header option.","ref":"Phoenix.Ecto.SQL.Sandbox.html","title":"Phoenix.Ecto.SQL.Sandbox","type":"module"},{"doc":"","ref":"Phoenix.Ecto.SQL.Sandbox.html#call/2","title":"Phoenix.Ecto.SQL.Sandbox.call/2","type":"function"},{"doc":"Decodes encoded metadata back into map generated from metadata_for/2.","ref":"Phoenix.Ecto.SQL.Sandbox.html#decode_metadata/1","title":"Phoenix.Ecto.SQL.Sandbox.decode_metadata/1","type":"function"},{"doc":"Encodes metadata generated by metadata_for/2 for client response.","ref":"Phoenix.Ecto.SQL.Sandbox.html#encode_metadata/1","title":"Phoenix.Ecto.SQL.Sandbox.encode_metadata/1","type":"function"},{"doc":"","ref":"Phoenix.Ecto.SQL.Sandbox.html#init/1","title":"Phoenix.Ecto.SQL.Sandbox.init/1","type":"function"},{"doc":"Returns metadata to associate with the session to allow the endpoint to access the database connection checked out by the test process.","ref":"Phoenix.Ecto.SQL.Sandbox.html#metadata_for/2","title":"Phoenix.Ecto.SQL.Sandbox.metadata_for/2","type":"function"},{"doc":"Spawns a sandbox session to checkout a connection for a remote client.Examplesiex&gt; {:ok, _owner_pid, metadata} = start_child(MyApp.Repo)","ref":"Phoenix.Ecto.SQL.Sandbox.html#start_child/2","title":"Phoenix.Ecto.SQL.Sandbox.start_child/2","type":"function"},{"doc":"Stops a sandbox session holding a connection for a remote client.Examplesiex&gt; {:ok, owner_pid, metadata} = start_child(MyApp.Repo) iex&gt; :ok = stop(owner_pid)","ref":"Phoenix.Ecto.SQL.Sandbox.html#stop/1","title":"Phoenix.Ecto.SQL.Sandbox.stop/1","type":"function"},{"doc":"","ref":"Phoenix.Ecto.PendingMigrationError.html","title":"Phoenix.Ecto.PendingMigrationError","type":"exception"},{"doc":"Callback implementation for Exception.message/1.","ref":"Phoenix.Ecto.PendingMigrationError.html#message/1","title":"Phoenix.Ecto.PendingMigrationError.message/1","type":"function"},{"doc":"","ref":"Phoenix.Ecto.StorageNotCreatedError.html","title":"Phoenix.Ecto.StorageNotCreatedError","type":"exception"},{"doc":"Callback implementation for Exception.message/1.","ref":"Phoenix.Ecto.StorageNotCreatedError.html#message/1","title":"Phoenix.Ecto.StorageNotCreatedError.message/1","type":"function"},{"doc":"A project that integrates Phoenix with Ecto, implementing all relevant protocols.","ref":"main.html","title":"Phoenix/Ecto","type":"extras"},{"doc":"You can use phoenix_ecto in your projects in two steps:Add it to your mix.exs dependencies: def deps do [{:phoenix_ecto, &quot;~&gt; 4.0&quot;}] endList it as your application dependency: def application do [applications: [:logger, :phoenix_ecto]] end","ref":"main.html#usage","title":"Phoenix/Ecto - Usage","type":"extras"},{"doc":"This library also provides a plug called Phoenix.Ecto.SQL.Sandbox that allows developers to run acceptance tests powered by headless browsers such as ChromeDriver and Selenium concurrently. If you are not familiar with Ecto's SQL sandbox, we recommend you to first get acquainted with it by reading Ecto.Adapters.SQL.Sandbox documentation.To enable concurrent acceptance tests, make sure you are using PostgreSQL and follow the instructions below:Set a flag to enable the sandbox in config/test.exs: config :your_app, sql_sandbox: trueAnd use the flag to conditionally add the plug to lib/your_app/endpoint.ex: if Application.get_env(:your_app, :sql_sandbox) do plug Phoenix.Ecto.SQL.Sandbox end Make sure that this is placed before the line plug YourApp.Router (or any other plug that may access the database).You can now checkout a sandboxed connection and pass the connection information to an acceptance testing tool like Hound or Wallaby.HoundTo write concurrent acceptance tests with Hound, first add it as a dependency to your mix.exs:{:hound, &quot;~&gt; 1.0&quot;}Make sure to start it at the top of your test/test_helper.exs:{:ok, _} = Application.ensure_all_started(:hound)Then add the following to your test case (or case template):use Hound.Helpers setup do :ok = Ecto.Adapters.SQL.Sandbox.checkout(YourApp.Repo) metadata = Phoenix.Ecto.SQL.Sandbox.metadata_for(YourApp.Repo, self()) Hound.start_session(metadata: metadata) :ok endHound supports multiple drivers like Chrome, Firefox, etc but it does not support concurrent tests under PhantomJS (the default).WallabyTo write concurrent acceptance tests with Wallaby, first add it as a dependency to your mix.exs:{:wallaby, &quot;~&gt; 0.25&quot;, only: :test}Wallaby can take care of setting up the Ecto Sandbox for you if you use use Wallaby.Feature in your test module.defmodule MyAppWeb.PageFeature do use ExUnit.Case, async: true use Wallaby.Feature feature &quot;shows some text&quot;, %{session: session} do session |&gt; visit(&quot;/home&quot;) |&gt; assert_text(&quot;Hello world!&quot;) end endIf you don't use Wallaby.Feature, you can add the following to your test case (or case template):use Wallaby.DSL setup do :ok = Ecto.Adapters.SQL.Sandbox.checkout(YourApp.Repo) metadata = Phoenix.Ecto.SQL.Sandbox.metadata_for(YourApp.Repo, self()) {:ok, session} = Wallaby.start_session(metadata: metadata) endWallaby currently supports ChromeDriver and Selenium, allowing testing in almost any browser.","ref":"main.html#concurrent-browser-tests","title":"Phoenix/Ecto - Concurrent browser tests","type":"extras"},{"doc":"Thanks to Elixir protocols, the integration between Phoenix and Ecto is simply a matter of implementing a handful of protocols. We provide the following implementations:Phoenix.HTML.FormData protocol for Ecto.ChangesetPhoenix.HTML.Safe protocol for DecimalPlug.Exception protocol for the relevant Ecto exceptions","ref":"main.html#the-phoenix-ecto-integration","title":"Phoenix/Ecto - The Phoenix &lt;-&gt; Ecto integration","type":"extras"},{"doc":"The Plug.Exception implementations for Ecto exceptions may be disabled by including the error in the mix configuration.config :phoenix_ecto, exclude_ecto_exceptions_from_plug: [Ecto.NoResultsError]","ref":"main.html#configuration","title":"Phoenix/Ecto - Configuration","type":"extras"},{"doc":"Same license as Phoenix.","ref":"main.html#license","title":"Phoenix/Ecto - License","type":"extras"}]